/* COADA 
 * 
 * Principiul Cozii: FIFO (First In - First Out)
 * 
 * Este o structura de date LINIARA (sir, queue)
 * care admite 2 operatii:
 * 
 * 1. Adauga un element la sfarsitul cozii (push(x))
 * 2. Sterge primul element al cozii (sterge capul cozii) pop()
 */ 
 
// Implementare cu sir

#include <iostream>
#include <stack>
#include <string>
using namespace std;


int Q[1000];      // coada
int p = 0;        // pozitia primului element din coada
int u = -1;       // pozitia ultimului element din coada

// Operatii
void push(int x); // adauga un elem la sf cozii
void pop();       // sterge primul elem din coada

// functii de informare
int front();      // returneza primul elem din coada
int back();       // returneaza ultimul element din coada
bool empty();     // returneaza true adca coada este vida
int size();       // returneaza nr de elem din coada

 
int main()
{
	push(10); push(20); push(30); push(40); push(50);
	
	while (!empty())
	{
		cout << front() << ' ';
		pop();
	}
	
	return 0;
}

// Operatii
void push(int x) // adauga x la sfarsit
{
	Q[++u] = x;
}

void pop()       // sterge primul elem din coada
{
	p++;
}

// functii de informare
int front() 
{
	return Q[p];
}

int back()
{
	return Q[u];
}

bool empty()
{
	return p > u;
}

int size()
{
	return u - p + 1;
}

